








































































	.text
	.align	8, 0x90
	.globl	__gmpn_sqr_basecase_nehalem
	.type	__gmpn_sqr_basecase_nehalem,@function
	
__gmpn_sqr_basecase_nehalem:






	movl	12(%esp), %edx
	movl	8(%esp), %eax
	movl	4(%esp), %ecx

	cmpl	$2, %edx

	je	.Ltwo_limbs
	ja	.Lthree_or_more



	
	
	
	

	movl	(%eax), %eax
	mull	%eax

	movl	%eax, (%ecx)
	movl	%edx, 4(%ecx)

	ret




.Ltwo_limbs:
	
	
	
	

	movd	(%eax), %mm1
	movd	4(%eax), %mm0
	pmuludq	%mm1, %mm0		

	pmuludq	%mm1, %mm1		

	movd	4(%eax), %mm2
	pmuludq	%mm2, %mm2		

	movd	%mm1, (%ecx)		
	psrlq	$32, %mm1

	pcmpeqd	%mm3, %mm3
	psrlq	$32, %mm3		
	pand	%mm0, %mm3		
	psrlq	$32, %mm0		

	psllq	$1, %mm3		
	paddq	%mm3, %mm1		
	movd	%mm1, 4(%ecx)		

	pcmpeqd	%mm4, %mm4
	psrlq	$32, %mm4		
	pand	%mm2, %mm4		
	psrlq	$32, %mm2		

	psllq	$1, %mm0		
	psrlq	$32, %mm1		
	paddq	%mm1, %mm0
	paddq	%mm4, %mm0		
	movd	%mm0, 8(%ecx)		

	psrlq	$32, %mm0		
	paddq	%mm2, %mm0		
	movd	%mm0, 12(%ecx)		

	

	emms
	ret





.Lthree_or_more:

	
	
	
	
	
	
	
	
	






	subl	$12, %esp	
	pxor	%mm0, %mm0		
	movd	(%eax), %mm7		

	movl	%esi, 8(%esp)
	movl	%edi, 4(%esp)
	movl	%ebp, (%esp)


	movl	%eax, %esi
	movl	%ecx, %edi
	subl	$1, %edx

	
.Lmul1:
	
	
	
	
	
	
	
	
	
	

	movd	4(%eax), %mm1
	addl	$4, %eax
	pmuludq	%mm7, %mm1
	paddq	%mm1, %mm0
	movd	%mm0, 4(%ecx)
	addl	$4, %ecx
	psrlq	$32, %mm0
	subl	$1, %edx
	jnz	.Lmul1


	movl	24(%esp), %ebp
	subl	$3, %ebp
	jz	.Lcorner


	
	
	
	

.Louter:
	
	
	
	
	
	
	
	
	

	movd	4(%esi), %mm7		
	movd	%mm0, 4(%ecx)		

	leal	8(%esi), %eax		
	addl	$4, %esi

	leal	8(%edi), %ecx		
	addl	$8, %edi

	leal	1(%ebp), %edx		

	pxor	%mm0, %mm0		

.Linner:
	
	
	
	
	
	
	
	
	

	movd	(%eax), %mm1
	leal	4(%eax), %eax
	movd	4(%ecx),%mm2
	pmuludq	%mm7, %mm1
	paddq	%mm2, %mm1
	paddq	%mm1, %mm0
	subl	$1, %edx
	movd	%mm0, 4(%ecx)
	psrlq	$32, %mm0
	leal	4(%ecx), %ecx
	jnz	.Linner

	subl	$1, %ebp
	jnz	.Louter


.Lcorner:
	
	
	
	
	
	
	
	
	
	

	movd	4(%esi), %mm1
	movd	8(%esi), %mm2
	pmuludq	%mm2, %mm1		

	movl	20(%esp), %eax
	movd	(%eax), %mm2
	pmuludq	%mm2, %mm2		

	pcmpeqd	%mm7, %mm7
	psrlq	$32, %mm7

	movl	16(%esp), %edx
	movd	4(%edx), %mm3		

	paddq	%mm1, %mm0
	movd	%mm0, 12(%edi)		

	psrlq	$32, %mm0
	movd	%mm0, 16(%edi)		

	movd	%mm2, (%edx)		
	psrlq	$32, %mm2

	psllq	$1, %mm3		
	paddq	%mm3, %mm2
	movd	%mm2, 4(%edx)
	psrlq	$32, %mm2

	movl	24(%esp), %ecx
	subl	$2, %ecx

	
	
	

.Ldiag:
	
	
	
	
	
	
	
	
	
	

	movd	4(%eax), %mm0	
	addl	$4, %eax
	pmuludq	%mm0, %mm0
	movq	%mm7, %mm1
	pand	%mm0, %mm1	
	psrlq	$32, %mm0	

	movd	8(%edx), %mm3
	psllq	$1, %mm3	
	paddq	%mm3, %mm1
	paddq	%mm1, %mm2
	movd	%mm2, 8(%edx)
	psrlq	$32, %mm2

	movd	12(%edx), %mm3
	psllq	$1, %mm3	
	paddq	%mm3, %mm0
	paddq	%mm0, %mm2
	movd	%mm2, 12(%edx)
	addl	$8, %edx
	psrlq	$32, %mm2

	subl	$1, %ecx
	jnz	.Ldiag


	movd	4(%eax), %mm0	
	pmuludq	%mm0, %mm0
	pand	%mm0, %mm7	
	psrlq	$32, %mm0	

	movd	8(%edx), %mm3	
	psllq	$1, %mm3
	paddq	%mm3, %mm7
	paddq	%mm7, %mm2
	movd	%mm2, 8(%edx)
	psrlq	$32, %mm2

	paddq	%mm0, %mm2
	movd	%mm2, 12(%edx)	

	


	movl	8(%esp), %esi
	movl	4(%esp), %edi
	movl	(%esp), %ebp
	addl	$12, %esp
	emms
	ret



	.size	__gmpn_sqr_basecase_nehalem,.-__gmpn_sqr_basecase_nehalem


