













































































































	.text
	.align	32, 0x90
	.globl	__gmpn_mul_1c_k7
	.type	__gmpn_mul_1c_k7,@function
	
__gmpn_mul_1c_k7:





	movl	20(%esp), %edx
	jmp	.Lstart_nc
	.size	__gmpn_mul_1c_k7,.-__gmpn_mul_1c_k7


	.globl	__gmpn_mul_1_k7
	.type	__gmpn_mul_1_k7,@function
	
__gmpn_mul_1_k7:





	xorl	%edx, %edx	
.Lstart_nc:
	movl	12(%esp), %ecx
	subl	$16, %esp


	movl	%edi, 8(%esp)
	movl	%ebx, (%esp)
	movl	%edx, %ebx

	movl	%esi, 4(%esp)
	movl	24(%esp), %esi
	cmpl	$7, %ecx

	movl	20(%esp), %edi
	movl	%ebp, 12(%esp)
	jae	.Lunroll

	leal	(%esi,%ecx,4), %esi
	leal	(%edi,%ecx,4), %edi
	negl	%ecx

	movl	32(%esp), %ebp

.Lsimple:
	
	
	
	
	
	
	

	movl	(%esi,%ecx,4), %eax

	mull	%ebp

	addl	%ebx, %eax
	movl	%eax, (%edi,%ecx,4)
	movl	$0, %ebx

	adcl	%edx, %ebx
	incl	%ecx
	jnz	.Lsimple

	movl	%ebx, %eax
	movl	(%esp), %ebx
	movl	4(%esp), %esi

	movl	8(%esp), %edi
	movl	12(%esp), %ebp
	addl	$16, %esp

	ret

















	
.Lunroll:
	
	
	
	
	
	
	


	leal	-1(%ecx), %edx	
	leal	-2(%ecx), %ecx	
	movl	%ebp, 12(%esp)

	negl	%edx
	shrl	$4, %ecx	
	movl	(%esi), %eax		

	andl	$15, %edx
	movl	20(%esp), %edi

	movl	%edx, %ebp
	shll	$4, %edx

	

	call	.Ladd_eip_to_edx
.Lhere:

	negl	%ebp

	leal	 (%esi,%ebp,4), %esi
	leal	 (%edi,%ebp,4), %edi
	movl	32(%esp), %ebp

	jmp	*%edx



.Ladd_eip_to_edx:
	
	leal	(%edx,%ebp), %edx
	addl	$.Lentry-.Lhere, %edx
	addl	(%esp), %edx
	ret




	.align	32, 0x90
.Ltop:
	
	
	
	
	
	
	
	
	

.Lentry:

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	4(%esi), %eax
	.byte	0x89,0x5f,0x00  


	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	8(%esi), %eax
	movl	%ebx, 4(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	12(%esi), %eax
	movl	%ebx, 8(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	16(%esi), %eax
	movl	%ebx, 12(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	20(%esi), %eax
	movl	%ebx, 16(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	24(%esi), %eax
	movl	%ebx, 20(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	28(%esi), %eax
	movl	%ebx, 24(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	32(%esi), %eax
	movl	%ebx, 28(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	36(%esi), %eax
	movl	%ebx, 32(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	40(%esi), %eax
	movl	%ebx, 36(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	44(%esi), %eax
	movl	%ebx, 40(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	48(%esi), %eax
	movl	%ebx, 44(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	52(%esi), %eax
	movl	%ebx, 48(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	56(%esi), %eax
	movl	%ebx, 52(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	60(%esi), %eax
	movl	%ebx, 56(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx

	
	

	mull	%ebp

	addl	%eax, %ebx
	movl	64(%esi), %eax
	movl	%ebx, 60(%edi)

	movl	$0, %ebx
	adcl	%edx, %ebx


	decl	%ecx

	leal	64(%esi), %esi
	leal	64(%edi), %edi
	jns	.Ltop




	mull	%ebp

	addl	%eax, %ebx
	movl	$0, %eax
	movl	4(%esp), %esi

	movl	%ebx, (%edi)
	movl	(%esp), %ebx
	movl	8(%esp), %edi

	adcl	%edx, %eax
	movl	12(%esp), %ebp
	addl	$16, %esp

	ret



	.size	__gmpn_mul_1_k7,.-__gmpn_mul_1_k7


